using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;

namespace GGC_FilterBar_DropDownUserControl
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(24, 24);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(536, 256);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.201.0.37";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(584, 302);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "GGC_FilterBar_DropDownUserControl ...";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable parentTable = GetParentTable();
			DataTable childTable = GetChildTable();
			DataSet ds = new DataSet();
			ds.Tables.Add(parentTable);
			ds.Tables.Add(childTable);
			ds.Relations.Add("Relation",ds.Tables["ParentTable"].Columns["parentID"],ds.Tables["ChildTable"].Columns["parentID"]);
			
			this.gridGroupingControl1.DataSource = ds;
			this.gridGroupingControl1.DataMember = "ParentTable";

			this.gridGroupingControl1.TableDescriptor.AllowNew = false;
			
			//allow 2 filterbar entries
			this.gridGroupingControl1.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridGroupingControl1.TableDescriptor.Columns["ParentName"].AllowFilter = true;
			this.gridGroupingControl1.TableDescriptor.Columns["parentID"].AllowFilter = true;			

			this.gridGroupingControl1.TableDescriptor.Columns["DOB"].AllowFilter = true;			

			//add a custom cell type
			CustomFilterBarCellModel model = new CustomFilterBarCellModel(this.gridGroupingControl1.TableModel);
			this.gridGroupingControl1.TableModel.CellModels.Add("CustFilterBarCell", model);

			//make filter bar cells use our custom cell type
			this.gridGroupingControl1.TableDescriptor.Appearance.FilterBarCell.CellType = "CustFilterBarCell";			
			this.gridGroupingControl1.TableDescriptor.Columns["DOB"].Appearance.FilterBarCell.CellType = "MonthCalendar";			
			this.gridGroupingControl1.TableDescriptor.Columns["DOB"].Appearance.FilterBarCell.BackColor = Color.Pink;			

			this.gridGroupingControl1.TableControlCurrentCellCloseDropDown +=new GridTableControlPopupClosedEventHandler(gridGroupingControl1_TableControlCurrentCellCloseDropDown);

			this.gridGroupingControl1.TableControlDrawCell +=new GridTableControlDrawCellEventHandler(gridGroupingControl1_TableControlDrawCell);
		}	

		# region  [   DataTable...   ]
		private int numberParentRows = 5;
		private int numberChildRows = 20;
		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("parentID")); //lower case p
			dt.Columns.Add(new DataColumn("ParentName"));
			dt.Columns.Add(new DataColumn("ParentDec"));
			dt.Columns.Add(new DataColumn("DOB",typeof(DateTime)));

			for(int i = 0; i < numberParentRows; i++)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i;//.ToString();
				dr[1] = string.Format("parentName{0}", i);
				dr[2] = string.Format("parentName{0}", i);
				dr[3] = DateTime.Today.AddDays(i%2);  

				dt.Rows.Add(dr);
			}

			return dt;
		}

		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable");

			dt.Columns.Add(new DataColumn("childID")); //lower case c
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ParentID")); //upper case P
			
			for(int i = 0; i < numberChildRows; i++)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("ChildName{0}",i);
				dr[2] = (i % numberParentRows).ToString();
				dt.Rows.Add(dr);
			}
		
			return dt;
		}
		# endregion

		string objFilterValue = string.Empty;
		private void gridGroupingControl1_TableControlCurrentCellCloseDropDown(object sender, GridTableControlPopupClosedEventArgs e)
		{
			GridCurrentCell cc = e.TableControl.CurrentCell;
			GridDropDownMonthCalendarCellRenderer  cr = cc.Renderer as GridDropDownMonthCalendarCellRenderer;  
			if( cr != null )
			{
				GridTableCellStyleInfo style = cr.CurrentStyle as GridTableCellStyleInfo; 
				if(  style.TableCellIdentity.DisplayElement.Kind == DisplayElementKind.FilterBar  )
				{
					objFilterValue = cr.ControlValue.ToString();  
					e.TableControl.TableDescriptor.RecordFilters.Remove("DOB"); 
					e.TableControl.TableDescriptor.RecordFilters.Add("DOB",Syncfusion.Grouping.FilterCompareOperator.Match, cr.ControlValue);      
				}
			}
			
		}

		

		private void gridGroupingControl1_TableControlDrawCell(object sender, GridTableControlDrawCellEventArgs e)
		{
			GridTableCellStyleInfo style = e.Inner.Style as GridTableCellStyleInfo; 
			if( e.Inner.Style.CellType == "MonthCalendar"  
				&& style.TableCellIdentity.DisplayElement.Kind == DisplayElementKind.FilterBar  )
			{
				e.Inner.Cancel = true;
				e.Inner.Renderer.Draw(e.Inner.Graphics, e.Inner.Bounds,e.Inner.RowIndex,e.Inner.ColIndex,e.Inner.Style);             
				e.Inner.Graphics.DrawString(  objFilterValue,e.Inner.Style.GdipFont, new SolidBrush(e.Inner.Style.TextColor),e.Inner.Bounds);          
			}

		}
	}
}
